/**
 * JBoss, Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.thirdparty.remoting;

import org.jboss.remoting.transport.socket.MicroSocketClientInvoker;
import org.jboss.remoting.InvokerLocator;
import org.jboss.logging.Logger;

import java.net.Socket;
import java.io.OutputStream;

/**
 * @author <a href="mailto:ovidiu@jboss.org">Ovidiu Feodorov</a>
 * @version <tt>$Revision: 1.1.2.1 $</tt>
 *
 * $Id: TestClientInvoker.java,v 1.1.2.1 2007/01/16 00:29:29 ovidiu Exp $
 */
class TestClientInvoker extends MicroSocketClientInvoker
{
   // Constants ------------------------------------------------------------------------------------

   private static final Logger log = Logger.getLogger(TestClientInvoker.class);

   // Static ---------------------------------------------------------------------------------------

   // Attributes -----------------------------------------------------------------------------------

   // Constructors ---------------------------------------------------------------------------------

   public TestClientInvoker(InvokerLocator locator)
   {
      super(locator);
   }

   // Public ---------------------------------------------------------------------------------------

   public String toString()
   {
      return "TestClientInvoker[" + Integer.toHexString(hashCode()) + "]";
   }

   // Package protected ----------------------------------------------------------------------------

   Socket openConnectionButDontSendAnything() throws Exception
   {
      log.debug(this + " creating simple socket");

      Socket socket = new Socket(locator.getHost(), locator.getPort());

      log.debug(this + " created socket " + socket);

      return socket;
   }

   void openConnectionAndSendJunk() throws Exception
   {
      Socket socket = openConnectionButDontSendAnything();

      OutputStream os = socket.getOutputStream();

      os.write((byte)-1);

      log.debug(this + " wrote junk on socket");

//      os.flush();
//
//      log.debug(this + " flushed the stream");
   }


   // Protected ------------------------------------------------------------------------------------

   // Private --------------------------------------------------------------------------------------

   // Inner classes --------------------------------------------------------------------------------
}
